package com.tzld.piaoquan.longarticle.common.enums;

public enum NewContentStatusEnum {

    DEFAULT(0, "初始状态"),
    KIMI_SUCCESS(101, "kimi执行成功"),
    CRAWLER_SUCCESS(102, "爬取视频成功"),
    ELT_SUCCESS(103, "下载成功"),
    KIMI_FAIL(201, "kimi执行失败"),
    CRAWLER_FAIL(202, "爬取视频失败"),
    ELT_FAIL(203, "下载失败");


    private final int statusCode;
    private final String message;

    NewContentStatusEnum(int statusCode, String message) {
        this.statusCode = statusCode;
        this.message = message;
    }

    public int getStatusCode() {
        return statusCode;
    }

    public String getMessage() {
        return message;
    }

    // 判断是否为成功状态
    public static boolean isSuccess(int contentStatus) {
        return contentStatus == ELT_SUCCESS.statusCode;
    }

    public static boolean isFail(int contentStatus) {
        return contentStatus == KIMI_FAIL.statusCode || contentStatus == CRAWLER_FAIL.statusCode
                || contentStatus == ELT_FAIL.statusCode;
    }

    // 获取错误信息
    public static String getErrorMessage(int contentStatus) {
        for (NewContentStatusEnum status : NewContentStatusEnum.values()) {
            if (status.statusCode == contentStatus) {
                return status.message;
            }
        }
        return null;
    }
}
