package com.tzld.piaoquan.longarticle.config;

import com.alibaba.druid.pool.DruidDataSource;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.transaction.PlatformTransactionManager;

import javax.sql.DataSource;

@MapperScan(basePackages = GrowthDataSourceConfig.GROWTH_PACKAGE_MASTER, sqlSessionFactoryRef = "growthSqlSessionFactory")
@Configuration
public class GrowthDataSourceConfig {



    // 数据源
    static final String GROWTH_PACKAGE_MASTER = "com.tzld.piaoquan.longarticle.dao.mapper.growth";
    static final String GROWTH_MAPPER_LOCATION_MASTER = "classpath:mapper/growth/*.xml";

    @Bean(name = "growthDataSource")
    @ConfigurationProperties("growth.datasource")
    public DataSource getgrowthDataSource(){
        return new DruidDataSource();
    }

    @Bean(name = "growthTransactionManager")
    public PlatformTransactionManager growthTransactionManager(@Qualifier("growthDataSource") DataSource dataSource) {
        return new DataSourceTransactionManager(dataSource);
    }

    @Bean(name = "growthSqlSessionFactory")
    public SqlSessionFactory growthSqlSessionFactory(@Qualifier("growthDataSource") DataSource dataSource) throws Exception {
        final SqlSessionFactoryBean sessionFactoryBean = new SqlSessionFactoryBean();
        sessionFactoryBean.setDataSource(dataSource);
        sessionFactoryBean.setMapperLocations(new PathMatchingResourcePatternResolver().getResources(GrowthDataSourceConfig.GROWTH_MAPPER_LOCATION_MASTER));
        return sessionFactoryBean.getObject();
    }

}
