package com.tzld.piaoquan.longarticle.service.local.impl;

import com.tzld.piaoquan.longarticle.dao.mapper.longarticle.CrawlerVideoMapper;
import com.tzld.piaoquan.longarticle.dao.mapper.longarticle.NewVideoCoverMapper;
import com.tzld.piaoquan.longarticle.model.po.longarticle.CrawlerVideo;
import com.tzld.piaoquan.longarticle.model.po.longarticle.NewVideoCover;
import com.tzld.piaoquan.longarticle.model.po.longarticle.NewVideoCoverExample;
import com.tzld.piaoquan.longarticle.service.local.CoverService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

@Service
public class CoverServiceImpl implements CoverService {

    @Autowired
    private CrawlerVideoMapper crawlerVideoMapper;

    @Autowired
    private NewVideoCoverMapper newVideoCoverMapper;


    public void getEffectiveVideo() {
        int pageSize = 500;
        Integer count = crawlerVideoMapper.selectEffectiveVideoCount();
        for (int i = 0; i < count; i += pageSize) {
            List<CrawlerVideo> crawlerVideos = crawlerVideoMapper.selectEffectiveVideo(i, i + pageSize);
            if (CollectionUtils.isEmpty(crawlerVideos)) {
                continue;
            }
            for (CrawlerVideo crawlerVideo : crawlerVideos) {
                Integer crawlerVideoId = crawlerVideo.getId();
                NewVideoCoverExample example = new NewVideoCoverExample();
                example.createCriteria().andCrawlerVideoIdEqualTo(crawlerVideoId);
                long l = newVideoCoverMapper.countByExample(example);
                if(l > 0){
                    continue;
                }
                NewVideoCover newVideoCover = new NewVideoCover();
                newVideoCover.setCrawlerVideoId(crawlerVideo.getId());
                newVideoCover.setVersion(1);
                newVideoCover.setVideoOssPath(crawlerVideo.getVideoOssPath());
                newVideoCoverMapper.insertSelective(newVideoCover);
            }
        }
    }

}
