package com.tzld.piaoquan.longarticle.utils;

import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.Map;

@Slf4j
public class VideoUtils {

    private static final String VIDEO_DETAIL_URL = "https://longvideoapi.piaoquantv.com/longvideoapi/openapi/video/batchSelectVideoInfo";


    public static JSONObject getVideoDetail(Long videoId) {
        JSONObject params = new JSONObject();
        Map<String, Object> data = new HashMap<>();
        data.put("videoIdList", new String[]{String.valueOf(videoId)});
        HttpResponse response = HttpRequest.post(VIDEO_DETAIL_URL)
                .header("Content-Type", "application/json")
                .body(JSONUtil.toJsonStr(data)) // 将数据转换为 JSON 字符串
                .execute();
        JSONObject jsonObject = JSONObject.parseObject(response.body());
        if (jsonObject.getJSONArray("data") != null) {
            return jsonObject.getJSONArray("data").getJSONObject(0);
        } else {
            return null;
        }
    }

    public static void main(String[] args) {
        System.out.println(getVideoDetail(11466300L).getString("ossVideoPath"));
    }
}
