package com.tzld.piaoquan.longarticle.utils.other;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.longarticle.utils.LarkRobotUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.util.*;

@Slf4j
public class NlpUtils {

    private static final String nlp_base_url_1 = "http://61.48.133.26:6060/nlp";
    private static final String nlp_base_url_2 = "http://192.168.203.4:6060/nlp";

    public static void main(String[] args) {
        String title1 = "在女儿出嫁的那神圣时刻，交接仪式上的父亲。。。";
        String title2 = "转载：““和老婆置气，我去女儿家避难。女。。。";
        String title3 = "“姨夫”和“姑父”哪个亲为何一个是父亲的父，一个是丈夫的夫";
        List<String> titleList = new ArrayList<>();
        titleList.add(title1);
        titleList.add(title2);
        titleList.add(title3);
        System.out.println(nlpTitleSimilarity(nlp_base_url_1, "这是我的女儿", titleList));
    }

    public static List<Float> getTitleSimilarityWithNlp(String oriTitle, List<String> titleList) {
        List<Float> baseScores;
        baseScores = NlpUtils.baseNlpTitleSimilarity1(oriTitle, titleList);
        if (!CollectionUtils.isEmpty(baseScores)) {
            return baseScores;
        }
        baseScores = NlpUtils.baseNlpTitleSimilarity2(oriTitle, titleList);
        if (!CollectionUtils.isEmpty(baseScores)) {
            return baseScores;
        }
        return null;
    }

    public static List<Float> baseNlpTitleSimilarity1(String oriTitle, List<String> titleList){
        return nlpTitleSimilarity(nlp_base_url_1, oriTitle, titleList);
    }

    public static List<Float> baseNlpTitleSimilarity2(String oriTitle, List<String> titleList){
        return nlpTitleSimilarity(nlp_base_url_2, oriTitle, titleList);
    }

    public static List<Float> nlpTitleSimilarity(String url, String oriTitle, List<String> titleList) {
        List<String> oriTitles = Collections.singletonList(oriTitle);

        JSONObject param = new JSONObject();
        JSONObject data = new JSONObject();
        data.put("text_list_a", oriTitles);
        data.put("text_list_b", titleList);
        param.put("data", data);
        param.put("function", "similarities_cross");
        param.put("use_cache", false);
        try {
            String body = HttpRequest.post(url)
                    .header("Content-Type", "application/json")
                    .body(JSONObject.toJSONString(param))
                    .execute()
                    .body();
            JSONObject jsonObject = JSONObject.parseObject(body);
            JSONArray scoreListList = jsonObject.getJSONArray("score_list_list").getJSONArray(0);
            if (!CollectionUtils.isEmpty(scoreListList)) {
                return scoreListList.toJavaList(Float.class);
            }
        } catch (Exception e) {
            log.error("NlpUtils nlpTitleSimilarity error", e);
        }
        return null;
    }
}
